	xdef	START
	
	section	program,code
	
*************************************************
**         declaration des constantes          **
*************************************************
	
numtest	equ	10		* nombre de tests du clavier
delai	equ	80
	
PGCR	equ	$10001		* configuration globale
PACR	equ	$1000D
PBCR	equ	$1000F
PADDR	equ	$10005		* masque de lecture du port A
PBDDR	equ	$10007
PCDDR	equ	$10009
PADR	equ	$10011		* adresse du port A
PBDR	equ	$10013
PCDR	equ	$10019
	
	
	
	
	
*************************************************
**                debut du code                **
*************************************************
	
START
	move.b	#$00,PGCR	* initialisation du PIT
	move.b  #$C0,PACR
	move.b	#$C0,PBCR
	
	move.b	#%00101011,PADDR	* masque du clavier
	move.b	#$FF,PBDDR	* toutes les cathodes sont en ecriture
	move.b	#$FF,PCDDR	* autorise clock($02) et reset($01) sur le MAX
	
	move.b	#$03,PCDR	* effectue un reset
	move.b	#$00,PCDR
	
	move.l	#af,A0		* met l'adresse du buffer dans A0
	move.l	#$FFFFFFFE,D0
preinitbuff
	move.b	D0,(A0)+
	rol.b	#$1,D0
	btst	#$7,D0
	bne	preinitbuff
	move.l	#0,D0
	move.l	#0,D1
	move.l	#0,D2
	move.l	#0,D3
	move.l	#0,D4
	move.l	#0,D5
	move.l	#0,D6
	move.l	#0,D7
	move.l	#0,A0
	move.l	#0,A1
	move.l	#0,A2
	move.l	#0,A3
	move.l	#0,A4
	move.l	#0,A5
	move.l	#0,A6
	move.l	#0,A7
	
	
	
***      debut de la boucle principale        ***
	
boucleprincipale
	bsr	litclavier	* lit le clavier
	
	move.w	(cl),D0
	move.l	#ch0,A1		* fait pointer A1 sur le premier caractere

	
	move.l	#$0F,D1		* 16 bits a tester
prclavtst
	btst	#$0,D0		* si on trouve le premier bit allume
	beq	prinitrecop	* on affiche le caractere selectionne
	rol.w	#$1,D0		* sinon on regarde le bit suivant
	* on peut aussi tenter de tester les bits par btst D1,D0
	add.l	#$7,A1		* fait pointer A1 sur le caractere suivant
	dbra	D1,prclavtst	* recommence s'il reste des bits a tester

	move.l	#vide,A1	* sinon affiche l'image par defaut
	
prinitrecop
	move.l	#$6,D1		* 7 lignes a recopier
	move.l	#af,A0		* sur l'ecran virtuel
prrecop
	move.b	(A1)+,(A0)+	* recopie le buffer
	dbra	D1,prrecop	* regarde la ligne suivante
	
praffich
*	bsr	permuteecran	* traduit l'ecran virtuel en ecran reel

	move.l	#af,A1
	move.l	#ar,A0
	move.l	#$6,D0
ooo	move.b	(A1)+,(A0)+
	dbra	D0,ooo
	
	bsr	afficheecran	* affiche l'ecran
	
	bra	boucleprincipale	* recommence
	
	trap	#15		* fin du programme (jamais atteint)
	dc.w	$0
	
***           fin boucle principale           ***
		


		
*** debut de la routine de permutation ecran  ***
	
permuteecran
	move.l	#af,A0		* initialise l'adresse de l'ecran virtuel
	move.l	#ar,A1		* initialise l'adresse de l'ecran reel
	
	move.l	#$6,D6		* va recopier 7 lignes
permlignesuiv
	move.b	(A0)+,D0	* charge la ligne virtuelle
	move.l	#$FF,D1		* initialise la ligne reelle a "eteint"
	move.l	#tabperaf,A2	* charge l'adresse de la table de permutations
	
	move.b	#$7,D7		* va permuter 8 bits
permbitsuiv
	move.l	(A2),D2		* charge la nouvelle position du bit en cours
	add.l	#$4,A2		* pointe sur la position suivante de permutation
	btst	#$0,D0		* teste le dernier bit de D0
	beq	bitvide
	bclr	D2,D1		* met le bit correspondant de D1 a 0
bitvide
	rol.b	#$1,D0		* regarde le bit suivant de D0
	
	dbra	D7,permbitsuiv

	move.b	D1,(A1)+	* sauvegarde la ligne dans le buffer reel
	
	dbra	D6,permlignesuiv	* recommence avec la ligne suivante
	
	rts
	dc.w	$0
***  fin de la routine de permutation ecran   ***
	


	
*** debut de la routine de lecture du clavier ***
	
litclavier			* lecture du clavier dans cl
	move.b	#%00101011,PADDR	* lignes en lecture
	* DO = valeur clav
	move.l	D0,D1		* enregistre l'ancienne valeur du clavier
	move.l	#numtest,D3	* reinitialise le compteur de tests
memetouche
	move.l	#$0,D0		* RAZ D0
	move.l	#$3,D2		* 4 lignes a tester
	
bclav				* test ligne par ligne :
	ror.w	#$4,D0		* decale D0 qui contient le resultat du test
	cmpi.b	#$3,D2		* switch sur la ligne a tester
	bne	lbla1
	move.b	#%00101010,PADR
	bra	lbla4
lbla1	
	cmpi.b	#$2,D2
	bne	lbla2
	move.b	#%00101001,PADR
	bra	lbla4
lbla2	
	cmpi.b	#$1,D2
	bne	lbla3
	move.b	#%00100011,PADR
	bra	lbla4
lbla3	
	move.b	#%00001011,PADR
	nop
lbla4	
	move.b	PADR,D7		* recupere le retour clavier dans D7
	
	btst	#$2,D7		* teste les touches de la ligne en cours
	beq	lblb1		* si le bit n'est pas zero, ne modifie pas D0
	bset	#$0,D0
lblb1	
	btst	#$4,D7
	beq	lblb2
	bset	#$1,D0
lblb2	
	btst	#$6,D7
	beq	lblb3
	bset	#$2,D0
lblb3	
	btst	#$7,D7
	beq	lblb4
	bset	#$3,D0
lblb4	
	dbra	D2,bclav	* il reste encore des lignes a lire
	
	cmp.w	D0,D1		* compare le resultat au precedant
	bne	litclavier	* si les touches ont chang, recommence
	
	dbra	D3,memetouche	* sinon teste encore une fois

	move.w	D0,(cl)		* sauvegarde le resultat de la lecture clavier
	
	rts			* fin de la procedure
	dc.w	$0
***  fin de la routine de lecture du clavier  ***
	

	
	
***      debut de la routine d'affichage      ***
	
afficheecran			* affichage du buffer d'ecran sur la matrice
	move.b	#$03,PCDR	* synchronisation du MAX (reset)
	move.b	#$00,PCDR	* les lignes sont eteintes
	
	move.l	#$06,D0		* initialisation du compteur de ligne courant
	
	move.l	#ar,A0		* met l'adresse de debut du buffer dans A0
	
affichesuiv
	
	move.b	(A0)+,PBDR	* mise a jour des anodes
	
	move.b	#$02,PCDR	* clock pour allumer la ligne
	move.b	#$00,PCDR
	
	move.l	#delai,D7
	bsr	tempo		* temporisation
	
	move.b	#$02,PCDR	* clock pour eteindre la ligne
	move.b	#$00,PCDR
	move.l	#$10,D7
	bsr	tempo

	dbra	D0,affichesuiv	* ligne suivante

	rts
	dc.w	$0
*** fin de la routine d'affichage de l'ecran  ***
	
	

	
***   debut de la routine de temporisation    ***
	
tempo
	nop
	dbra.l	D7,tempo
	
	rts
	dc.w	$0
***    fin de la routine de temporisation     ***
	
	

	
	
*************************************************
**          declaration des variables          **
*************************************************
af	ds.b	8		* buffer ecran virtuel
ar	ds.b	8		* buffer ecran reel (apres permutation)

tabperaf
	dc.l	$0		* position reele du 1 bit de la ligne virtuelle
	dc.l	$2
	dc.l	$5
	dc.l	$7
	dc.l	$1
	dc.l	$6
	dc.l	$4
	dc.l	$3

cl	ds.w	1		* buffer de clavier

ch0	dc.b	%1111111	* image des chiffres a afficher (0)
	dc.b	%1110111
	dc.b	%1001001
	dc.b	%1011101
	dc.b	%1001001
	dc.b	%1110111
	dc.b	%1111111
	
ch1	dc.b	%1111111	* image des chiffres a afficher (1)
	dc.b	%1110111
	dc.b	%1100111
	dc.b	%1010111
	dc.b	%1110111
	dc.b	%1100011
	dc.b	%1111111
	
ch2	dc.b	%1111111	* image des chiffres a afficher (2)
	dc.b	%1100011
	dc.b	%1011101
	dc.b	%1111011
	dc.b	%1100111
	dc.b	%1000001
	dc.b	%1111111
	
ch3	dc.b	%1111111	* image des chiffres a afficher (3)
	dc.b	%1100011
	dc.b	%1011101
	dc.b	%1110011
	dc.b	%1011101
	dc.b	%1100011
	dc.b	%1111111
	
ch4	dc.b	%1111111	* image des chiffres a afficher (4)
	dc.b	%1111011
	dc.b	%1110111
	dc.b	%1101011
	dc.b	%1000001
	dc.b	%1111011
	dc.b	%1111111

ch5	dc.b	%1111111	* image des chiffres a afficher (5)
	dc.b	%1000001
	dc.b	%1011111
	dc.b	%1000011
	dc.b	%1111101
	dc.b	%1000011
	dc.b	%1111111
	
ch6	dc.b	%1111111	* image des chiffres a afficher (0)
	dc.b	%1110001
	dc.b	%1101111
	dc.b	%1000011
	dc.b	%1011101
	dc.b	%1100011
	dc.b	%1111111
	 
ch7	dc.b	%1111111	* image des chiffres a afficher (7)
	dc.b	%1000001
	dc.b	%1110111
	dc.b	%1101111
	dc.b	%1011111
	dc.b	%1011111
	dc.b	%1111111
	
ch8	dc.b	%1111111	* image des chiffres a afficher (8)
	dc.b	%1100011
	dc.b	%1011101
	dc.b	%1100011
	dc.b	%1011101
	dc.b	%1100011
	dc.b	%1111111

ch9	dc.b	%1111111	* image des chiffres a afficher (9)
	dc.b	%1100011
	dc.b	%1011101
	dc.b	%1100001
	dc.b	%1111101
	dc.b	%1100011
	dc.b	%1111111
	
chA	dc.b	%1111111	* image des chiffres a afficher (A)
	dc.b	%1110111
	dc.b	%1101011
	dc.b	%1101011
	dc.b	%1000001
	dc.b	%1011101
	dc.b	%1111111
	
chB	dc.b	%1111111	* image des chiffres a afficher (B)
	dc.b	%1000011
	dc.b	%1011101
	dc.b	%1000011
	dc.b	%1011101
	dc.b	%1000011
	dc.b	%1111111
	
chC	dc.b	%1111111	* image des chiffres a afficher (C)
	dc.b	%1100011
	dc.b	%1011101
	dc.b	%1011111
	dc.b	%1011101
	dc.b	%1100011
	dc.b	%1111111
	
chD	dc.b	%1111111	* image des chiffres a afficher (D)
	dc.b	%1000011
	dc.b	%1011101
	dc.b	%1011101
	dc.b	%1011101
	dc.b	%1000011
	dc.b	%1111111
	
chE	dc.b	%1111111	* image des chiffres a afficher (E)
	dc.b	%1000001
	dc.b	%1011111
	dc.b	%1000011
	dc.b	%1011111
	dc.b	%1000001
	dc.b	%1111111
	
chF	dc.b	%1111111	* image des chiffres a afficher (F)
	dc.b	%1000001
	dc.b	%1011111
	dc.b	%1000011
	dc.b	%1011111
	dc.b	%1011111
	dc.b	%1111111
	
vide	dc.b	%0111110	* image a afficher quand le clavier est relache
	dc.b	%1011101
	dc.b	%1101011
	dc.b	%1110111
	dc.b	%1101011
	dc.b	%1011101
	dc.b	%0111110
	
	END
