	org $FF9100
	
	xdef	START
	section	program,code

delta_t		equ	625	; delai inter-interruptions du timer
*refresh		equ	375	; nb de delta_t par secondes
clavnumtest	equ	$A	; nombre de tests comparatifs des touches
periodeligne	equ	$FF	; toutes les n int, affichage de la ligne suiv
clignj2		equ	$FFF	; periode de clignotement du joueur 2




PGCR	equ	$10001

PADDR	equ	$10005		; masque d'io
PBDDR	equ	$10007
PCDDR	equ	$10009
PADR	equ	$10011		; valeur des bus
PBDR	equ	$10013
PCDR	equ	$10019
PACR	equ	$1000d
PBCR	equ	$1000f

TCR	equ	$10021		; adresses pour setup interruptions
TIVR	equ	$10023
CPR	equ	$27
CNTR	equ	$2f
TSR	equ	$10035


	move.l	#$FFFF83FC,a1	; adresse du vecteur 255
	lea	timer_ih,a2	; adresse du gestionnaire

	move.l	a2,(a1)		; init vecteur 255 avec la fonction qui va bien
	
	move.l	#$10000,a0	; adresse de base du PIT230
	move.b	#$10,PGCR
	move.b	#$c0,PACR
	move.b	#$c0,PBDR
	move.b	#$ff,PADDR
	move.b	#$ff,PBDDR
	move.b	#255,TIVR
	move.l	#delta_t,d0	; (7.500.000 / 32) / 375 = 625
	movep.l	d0,CPR-2(A0)	; setup du timer
	movep.l	d0,CNTR-2(A0)
	move.b	#$a1,TCR
	move.b	#$ff,PADR
	move.b	#$ff,PBDR
	move	#$2000,sr	; autorise interrupts ($2700 pour interdire)
	




*************************************************
**               initialisation                **
*************************************************
	
START
	move.b	#$00,PGCR	* initialisation du PIT
	move.b  #$C0,PACR
	move.b	#$C0,PBCR
	
	move.b	#%00101011,PADDR	* masque du clavier
	move.b	#$FF,PBDDR	* toutes les cathodes sont en ecriture
	move.b	#$FF,PCDDR	* autorise clock($02) et reset($01) sur le MAX
	
	bsr	clearscreen
	
*************************************************	
***      debut de la boucle principale        ***
*************************************************


boucleprincipale
	bsr	litclavier	* lit le clavier
	
	move.w	(cl),D0
	move.l	#ch0,A1		* fait pointer A1 sur le premier caractere

	
	move.l	#$0F,D1		* 16 bits a tester
prclavtst
	btst	#$0,D0		* si on trouve le premier bit allume
	beq	prinitrecop	* on affiche le caractere selectionne
	rol.w	#$1,D0		* sinon on regarde le bit suivant
	add.l	#$8,A1		* fait pointer A1 sur le caractere suivant
	dbra	D1,prclavtst	* recommence s'il reste des bits a tester

	move.l	#vide,A1	* sinon affiche l'image par defaut
	
prinitrecop
	move.l	#$6,D1		* 7 lignes a recopier
	move.l	#af,A0		* sur l'ecran virtuel
prrecop
	move.b	(A1)+,(A0)+	* recopie le buffer
	dbra	D1,prrecop	* regarde la ligne suivante
	
praffich
	bsr	permuteecran	* traduit l'ecran virtuel en ecran reel

	bsr	afficheecr	* affiche l'ecran
	
	bra	boucleprincipale	* recommence

fin	
	trap	#15		* fin du programme (jamais atteint)
	dc.w	0
	
***           fin boucle principale           ***
		


		
*** debut de la routine de permutation ecran  ***
	
permuteecran
	move.l	#af,A0		* initialise l'adresse de l'ecran virtuel
	move.l	#finar-1,A1		* initialise l'adresse de l'ecran reel
	
	move.l	#$7,D6		* va recopier 8 lignes
permlsuiv
	sub	#1,A1
	move.b	(A0)+,D0	* charge la ligne virtuelle
	move.b	#$FF,D1		* initialise la ligne reelle a "eteint"
	move.l	#tabperaf,A2	* charge l'adresse de la table de permutations
	
	move.l	#$7,D7		* va permuter 8 bits
permbitsuiv
	move.b	(A2)+,D2	* charge la nouvelle position du bit en cours
	btst	#0,D0		* teste le dernier bit de D0
	beq	bitvide
	and.b	D2,D1
bitvide
	ror.b	#$1,D0		* regarde le bit suivant de D0
	
	dbra	D7,permbitsuiv

	move.b	D1,(A1)		* sauvegarde la ligne dans le buffer reel
	
	dbra	D6,permlsuiv	* recommence avec la ligne suivante
	
	rts

***  fin de la routine de permutation ecran   ***
	


	
*** debut de la routine de lecture du clavier ***
	
litclavier			* lecture du clavier dans cl
	move.b	#%00101011,PADDR	* lignes en lecture
	* D0 = valeur clav
	move.l	D0,D1		* enregistre l'ancienne valeur du clavier
	move.l	#$10,D3		* reinitialise le compteur de tests
* move.l #numtest,D3
memetouche
	move.l	#$0,D0		* RAZ D0
	move.l	#$3,D2		* 4 lignes a tester
	
bclav				* test ligne par ligne :
	ror.w	#$4,D0		* decale D0 qui contient le resultat du test
	cmpi.b	#$3,D2		* switch sur la ligne a tester
	bne	lbla1
	move.b	#%00101010,PADR
	bra	lbla4
lbla1	
	cmpi.b	#$2,D2
	bne	lbla2
	move.b	#%00101001,PADR
	bra	lbla4
lbla2	
	cmpi.b	#$1,D2
	bne	lbla3
	move.b	#%00100011,PADR
	bra	lbla4
lbla3	
	move.b	#%00001011,PADR
	nop
lbla4	
	move.b	PADR,D7		* recupere le retour clavier dans D7
	
	btst	#$2,D7		* teste les touches de la ligne en cours
	beq	lblb1		* si le bit n'est pas zero, ne modifie pas D0
	bset	#$0,D0
lblb1	
	btst	#$4,D7
	beq	lblb2
	bset	#$1,D0
lblb2	
	btst	#$6,D7
	beq	lblb3
	bset	#$2,D0
lblb3	
	btst	#$7,D7
	beq	lblb4
	bset	#$3,D0
lblb4	
	dbra	D2,bclav	* il reste encore des lignes a lire
	
	cmp.w	D0,D1		* compare le resultat au precedant
	bne	litclavier	* si les touches ont chang, recommence
	
	dbra	D3,memetouche	* sinon teste encore une fois

	move.w	D0,(cl)		* sauvegarde le resultat de la lecture clavier
	
	rts			* fin de la procedure

***  fin de la routine de lecture du clavier  ***
	





*****************************************************
*** debut de la routine de gestion d'interruption ***
*****************************************************


timer_ih
	movem	D0-D7/A0-A6,-(A7)	; sauvegarde des registres sur la pile
	move.b	#$1,$10035	; relance le timer

	code_de_feu


	movem	(A7)+,D0-D7/A0-A6	; restauration a partir de la pile
	
	rte			; fin int
	
*** fin de la routine de gestion d'interruption ***




	
	
***      debut de la routine d'affichage      ***
	
afficheligne			* affichage d'une ligne
	move.b	#$02,PCDR	* extinction de la ligne precedante
	move.b	#$00,PCDR
	
	dbra	(lignaff),nrazlignaff
	move.l	#$06,(lignaff)
nrazlignaff
	
	move.l	#tab_oqp,A0	* met l'adresse du buffer de presence dans A0
	add.l	(lignaff),A0	* pointe sur la ligne en cours

	move.b	7(A0),D0	* lit la ligne en cours du buffer de joueur
	move.l	(time),D1	* lit l'heure

	move.b	(A0)+,PBDR	* mise a jour des anodes
	
	move.b	#$02,PCDR	* clock pour allumer la ligne
	move.b	#$00,PCDR
	
	rts

*** fin de la routine d'affichage de l'ecran  ***
	
clearscreen
	move.l	#af,A0		* met l'adresse du buffer dans A0
	move.b	#$0,(A0)+
	move.b	#$0,(A0)+
	move.b	#$0,(A0)+
	move.b	#$0,(A0)+
	move.b	#$0,(A0)+
	move.b	#$0,(A0)+
	move.b	#$0,(A0)
	
*************************************************
**          declaration des variables          **
*************************************************

tab_chute	ds.b	8	* buffer 1 = jeton en chute
tab_oqp		ds.b	8	* buffer 1 = jeton present
tab_j		ds.b	8	* buffer 1 = jeton au joueur 2

cl		dc.w	$0	* buffer de clavier (relache)


time		dc.l	$0	* compteur de temps (++ a chaque tick)
ligneaff	dc.b	$0	* ligne affiche (pour l'interrupt)

	
	END

