	org $FF9100
	
	xdef	_lectclavier,_PITinit
	section	program,code


**************************************************
*                   constantes                   *
**************************************************

***** pour le programme *****
clav_numtest	equ	$A	; nombre de tests comparatifs des touches

dureeaffligne	equ	$FF	; toutes les n int, affichage de la ligne suiv (mask)
dureechute	equ	$3FFF	; duree de stationnement dans une case sans plancher (mask>dureeaffligne)
dureeclignj2	equ	$1000	; periode de clignotement du joueur 2 (bit)


***** adresses *****
PGCR	equ	$10001

PADDR	equ	$10005		; masque d'io
PBDDR	equ	$10007
PCDDR	equ	$10009
PADR	equ	$10011		; valeur des bus
PBDR	equ	$10013
PCDR	equ	$10019
PACR	equ	$1000d
PBCR	equ	$1000f

TCR	equ	$10021		; adresses pour setup interruptions
TIVR	equ	$10023
CPR	equ	$27
CNTR	equ	$2F
TSR	equ	$10035



************************************************
*           initialisation du PIT              *
************************************************
_PITinit
	link.w	A6,#0
	movem.l	D0/A0-A2,-(A7)
	move.l	8(A6),delta_t
	move	#$2700,SR	; interdit les interrupts pendant l'initialisation

	move.l	#$FFFF83FC,A1	; adresse du vecteur 255
	lea	timerih,A2	; adresse du gestionnaire

	move.l	A2,(A1)		; init vecteur 255 avec la fonction qui va bien
	
	move.l	#$10000,A0	; adresse de base du PIT230
	move.b	#$00,PGCR	; initialisation du PIT en mode 0
	move.b	#$C0,PACR	; ports A et B en mode 1x
	move.b	#$C0,PBDR
	move.b	#$FF,PBDDR	; les cathodes sont en ecriture
	move.b	#$FF,PCDDR	; autorise clock($02) et reset($01)

	move.b	#$FF,PADR
	move.b	#$FF,PBDR
	move.l	#$0,ligneaff
	move.l	#$0,time
	move.l	#$0,victoire

	move.b	#$FF,TIVR
	move.l	delta_t,D0	; (7.500.000 / 32) / 375 = 625
	movep.l	D0,CPR-2(A0)	; programmation du timer
	movep.l	D0,CNTR-2(A0)
	move.b	#$A1,TCR
	move	#$2000,SR	; autorise interrupts
	movem.l	-8(A6),D0/A0-A2
	unlk		A6
	
	rts	
		


*************************************************
*        routine de lecture du clavier          *
*************************************************

_lectclavier			; lecture du clavier dans (D0)
	move.b	#%00101011,PADDR ; lecture des lignes
clav_start
	move.l	#clav_numtest,D3 ; reinitialise le compteur de tests
	
clav_memetouche
	move.l	D0,D1		; sauvegarde l'ancienne valeur du clavier
	move.l	#$0,D0		; RAZ D0
	move.l	#$3,D2		; 4 lignes a tester
	
clav_boucle			; test ligne par ligne :
	ror.w	#$4,D0		; decale D0 qui contient le resultat du test

* mise a 0 de la ligne a tester *
	cmpi.b	#$3,D2
	bne	clav_settest1
	move.b	#%00101010,PADR	; 1 test
	bra	clav_finsettest
clav_settest1
	cmpi.b	#$2,D2
	bne	clav_settest2
	move.b	#%00101001,PADR	; 2 test
	bra	clav_finsettest
clav_settest2
	cmpi.b	#$1,D2
	bne	clav_settest3
	move.b	#%00100011,PADR ; 3 test
	bra	clav_finsettest
clav_settest3
	move.b	#%00001011,PADR
	nop
clav_finsettest
	move.b	PADR,D7		; recupere le retour clavier dans D7
	
	btst	#$2,D7		; teste les touches de la ligne en cours
	beq	clav_gettest1	; si le bit n'est pas zero, ne modifie pas D0
	bset	#$0,D0
clav_gettest1
	btst	#$4,D7
	beq	clav_gettest2
	bset	#$1,D0
clav_gettest2
	btst	#$6,D7
	beq	clav_gettest3
	bset	#$2,D0
clav_gettest3
	btst	#$7,D7
	beq	clav_fingettest
	bset	#$3,D0
clav_fingettest

	dbra	D2,clav_boucle	; va tester la ligne suivante s'il en reste
	
	cmp.l	D0,D1		; compare avec le resultat du test precedant
	bne	clav_start	; si les touches ont chang, recommence a 0
	
	dbra	D3,clav_memetouche ; teste clav_numtest fois

	cmp.l	D0,lastclav	; compare la touche enfonce a la derniere lecture
	bne	clav_autretouche
	move.l	#$0,D0	; meme touche : renvoie 0
	rts

clav_autretouche
	move.l	D0,lastclav	; autre touche : la renvoie et la sauvegarde
	rts








*************************************************
* debut de la routine de gestion d'interruption *
*************************************************

timerih
	movem	D0-D7/A0-A6,-(A7) ; sauvegarde des registres sur la pile
	move.b	#$1,TSR		; relance le timer

	addq.l	#$1,time	; le temps passe
	
	move.l	time,D0
	and.l	dureeaffligne,D0 ; est-il l'heure d'afficher la ligne suivante ?
	bne	timerih_fin	; rien a faire
	bsr	lsuiv_start;
	
	move.l	time,D0
	and.l	dureechute,D0	; est-il l'heure de gerer les chutes ?
	bne	timerih_fin	; rien a faire
	bsr	chute_start

timerih_fin
	movem	(A7)+,D0-D7/A0-A6 ; restauration a partir de la pile
	
	rte			; fin interruption




********************************************************
* debut de la routine d'affichage de la ligne suivante *
********************************************************
	
lsuiv_start
	move.b	#$2,PCDR	; extinction de la ligne precedante par le MAX
	move.b	#$0,PCDR
	move.b	#$FF,PBDR	; extinction de la ligne par le PIT (pour eviter les fantomes)
	
	move.l	ligneaff,D0
	dbra	D0,lsuiv_lbl1
	move.l	#$06,D0
	move.b	#$1,PCDR	; reset
	move.b	#$0,PCDR
lsuiv_lbl1
	move.l	D0,ligneaff	; change de ligne
	
	move.l	#tab_oqp,A0	; met l'adresse du buffer de presence dans A0
	add.l	D0,A0		; A0 pointe sur la ligne en cours

	move.b	(A0),D0		; lit la ligne en cours du buffer de presence dans D0
	or.b	-8(A0),D0	; affiche aussi les pions en chute
	move.b	8(A0),D1	; lit la ligne en cours du buffer de joueur dans D1
	move.l	time,D2		; lit l'heure
	and.l	dureeclignj2,D2
	cmp.l	#$0,D2		; est-ce la periode pendant laquelle j1=j2 ?
	bne	lsuiv_lbl2
	move.b	#$0,D1		; oui : efface j2
lsuiv_lbl2

	and.b	D0,D1		; tab_j2 ne concerne que les cases occupees
	eor.b	D1,D0		; magic !

	move.b	D0,PBDR		; mise a jour des anodes
	move.b	#$02,PCDR	; allumage de la ligne courante par le MAX
	move.b	#$00,PCDR
	
	rts			; fin de la routine




********************************************************
* debut de la routine de gestion de la chute des pions *
********************************************************
	
chute_start
	move.l	#tab_chute,A0	; initialise A0 avec l'adresse de la premiere ligne du tableau (bas de l'ecran)
	move.l	#$6,D7		; 7 lignes a tester
	move.b	#$FF,D6		; initialise le tampon de tab_oqp(l-1) a 1 : les pions de la 1 ligne doivent s'arreter
	move.l	#$0,D2		; (D2,D1) indique les coordonnees (l,c) du bit en cours de test
	
chute_lboucle			; debut de la boucle sur les lignes
	move.b	(A0),D3		; lit la ligne en cours de tab_chute
	beq	chute_lfinie	; si elle est nulle, aucun pion en chute sur cette ligne : passe a la suivante

	move.l	#$6,D1		; 7 bits a tester

chute_bboucle			; debut de la boucle sur les bits
	btst	D1,D3		; regarde si il y a un pion en chute dans la case (D1,D2)
	beq	chute_bfini	; il n'y en a pas : regarde le bit suivant

	btst	D1,D6		; regarde si la case du dessous est occupe
	beq	chute_continue	; non : fait tomber le pion d'une case

	bclr	D1,(A0)		; oui : enleve le pion de tab_chute
	bset	D1,8(A0)	; pour le mettre dans tab_oqp (tab_j est a jour)

	*move.l	D2,-(A7)	; passage des parametres a la fonction en C
	*move.l	D1,-(A7)
	*bsr	Ctestvictoire	; appelle la fonction C de test de victoire
	*unlk	8,A7		; retour : 0 = pas de gagnant, 1 = victoire de 1, 2 = victoire de 2
	move.l	#$0,D0		; oh un bouchon

	cmp.l	#$0,D0
	beq	chute_bfini	; pas de gagnant : continue les tests

	move.l	D0,(victoire)	; met a jour la variable pour la boucle principale du programme
	bra	chute_fin	; et sors

chute_continue
	bclr	D1,(A0)		; met a jour tab_chute
	bset	D1,-1(A0)
	bclr	D1,16(A0)	; met a jour tab_j
	beq	chute_bfini	; bclr fait un btst en meme temps
	bset	D1,15(A0)	; la case tait occupe par le joueur 2 : lui laisse le pion

chute_bfini
	dbra	D1,chute_bboucle ; regarde le bit suivant

chute_lfinie
	move.b	8(A0),D6	; charge la ligne de presence correspondant a l'ancienne ligne dans D6
	add.l	#$1,A0		; incremente le pointeur de ligne
	add.l	#$1,D2		; et la variable qui le represente
	dbra	D7,chute_lboucle ; si on est encore dans le tableau, on recommence

chute_fin
	rts			; fin de la routine









*************************************************
**          declaration des variables          **
*************************************************

* tableaux : 7 lignes (0..6), ligne 6 = ligne du haut sur l'afficheur, +1 ligne pour l'alignement
* les bits sont dans l'ordre des cathodes
* les pions en chute ne sont pas dans tab_oqp
tab_chute	ds.b	8	; buffer, 1 = jeton en chute
tab_oqp		ds.b	8	; buffer, 1 = jeton present
tab_j		ds.b	8	; buffer, 1 = jeton au joueur 2

lastclav	dc.l	$0	; sauvegarde du clavier

time		dc.l	$0	; compteur de temps (++ a chaque tick)
ligneaff	dc.l	$0	; ligne affiche (pour l'interrupt)
victoire	dc.l	$0	; variable pour la boucle principale (vaut 1 si j1 a gagne)

delta_t	ds.l	1	; parametre de PITinit
	
	END

