* 68000 Startup Routine for Assembler Code Based Project
* This startup routine is provided as an example only.  It must be modified to suit your
* target system.

* The following block will be maintained by the Embedded Development Studio
* DO NOT EDIT
*{{EDS_STARTUP(A68000.ASM)
__NoRom equ 1
__LowestRomLocation equ 0400400H
__HighestRomLocation equ 047FFFFH
__LowestRamLocation equ 0479000H
__HighestRamLocation equ 047FFFFH
*}}EDS_STARTUP
* END OF DO NOT EDIT
* This is the end of the block that will be maintained by the Embedded Development Studio

******************************************************************************************

* Modify the code below to suit your particular target system and program requirements.


* Here and later in this file we assume that you will label 
* the start of your assembler code program with the label 'START'

	xref	START


**** Start of startup code for separate code and data ****

**** This code will be included when __NoRom is zero. Ie when the
**** "Code and data in ram" option in the linker settings has not been checked

	ifeq	__NoRom

	org     0
	* Initialise supervisor stack
	* We want to add 1 to __HighestRamLocation, but only if it is an odd address
	dc.l    __HighestRamLocation+__HighestRamLocation&1
	dc.l    START		Jump to START of users assembler code on power up
        
	endc				
**** End of startup code for separate code and data ****

**** Start of startup code for combined code and data ****

**** This code will be included when __NoRom is non-zero. Ie when the
**** "Code and data in ram" option in the linker settings has been checked
* We are assuming here that your target board already has a monitor or debugger
* running on it and that you are loading your program and data into data space
* on that target board.
* We are also assuming that this monitor/debugger is running in supervisor mode
* with its own stack. We need to set up the stack as the user stack and we may need 
* to switch to user mode.
* Before switching to user mode by clearing the S bit in the status register, 
* we need to ensure that we are not already in user mode - because MOVE <ea>,SR is
* a privileged instruction.  This is easy on the M68000 - just load the status
* register and check the 'S'bit.

	ifne	__NoRom

	org	__LowestRamLocation		Lowest user ram location
	even				Just in case an odd address has be put into the linker settings
	xdef __START
__START					* tell the linker the start address
	move	sr,d0		Get status reg
*	andi	#$2000,d0	Isolate supervisor bit
*	beq.s	skip1		Branch if the chip is already in user mode
	ori	#$2000,d0
	move	d0,sr
	bra.s	skip1


* The chip is in supervisor mode if here
	move	sr,d0		Get status register
	andi	#$dfff,d0	Clear S bit in status register
	move	d0,sr		Set user mode
	* Set user stack pointer.
	* We want to add 1 to __HighestRamLocation, but only if it is an odd address
skip1	movea.l	#__HighestRamLocation+__HighestRamLocation&1,a7
	jsr	START		Go to START of users assembler code

* Where execution goes from here depends on your target system. 
* A simple rts might be sufficient to return control to your target systems monitor/debugger.
* The code below is for a particular target board that requires a trap 11.

	trap	#15		Call monitor RENTER command
	dc.w	0		Re-enter monitor
	
	endc
**** End of startup code for combined code and data ****
	
