	xdef	START
	
	section	program,code
	
*************************************************
**         declaration des constantes          **
*************************************************
	
numtest	equ	20		* nombre de tests du clavier
delai	equ	100
	
PGCR	equ	$10001		* configuration globale
PACR	equ	$1000D
PBCR	equ	$1000F
PADDR	equ	$10005		* masque de lecture du port A
PBDDR	equ	$10007
PCDDR	equ	$10009
PADR	equ	$10011		* adresse du port A
PBDR	equ	$10013
PCDR	equ	$10019
	
	
*************************************************
**                debut du code                **
*************************************************
	
START
	move.b	#$00,PGCR	* initialisation du PIT
	move.b  #$C0,PACR
	move.b	#$C0,PBCR
	
	move.b	#%00101011,PADDR	* masque du clavier
	move.b	#$FF,PBDDR	* toutes les cathodes sont en ecriture
	move.b	#$03,PCDDR	* autorise clock($01) et reset($02) sur le MAX
	
	move.b	#$03,PCDR	* effectue un reset
	move.b	#$00,PCDR
	
	move.l	#af,A0
	move.b	#%01101111,(A0)+	* initiallisation du buffer lignes
	move.b	#%10101111,(A0)+
	move.b	#%11001111,(A0)+
	move.b	#%11100111,(A0)+
	move.b	#%11101011,(A0)+
	move.b	#%11101101,(A0)+
	move.b	#%11101110,(A0)

***      debut de la boucle principale        ***
	
boucleprincipale
	bsr	litclavier	* lit le clavier
	
	move.w	(cl),D0
	move.l	#$3,D2
	move.l	#ad,A0
	move.b	#$EF,(A0)+	* se positionne sur la 2 ligne
	
bcllignesuiv
	move.b	#$EF,D1		* reinitialise D1
	
	btst	#$0,D0		* allume les bonnes diodes de la ligne
	bne	lblc1
	and.b	#%11101110,D1
lblc1
	btst	#$1,D0
	bne	lblc2
	and.b	#%11101101,D1
lblc2
	btst	#$2,D0
	bne	lblc3
	and.b	#%11101011,D1
lblc3
	btst	#$3,D0
	bne	lblc4
	and.b	#%11100111,D1
lblc4
	move.b	D1,(A0)+	* met a jour le buffer
	dbra	D2,bcllignesuiv	* regarde la ligne suivante
	
	move.b	#$EF,(A0)+
	move.b	#$EF,(A0)
	
	bsr	afficheecran	* affiche l'ecran
	
	bra	boucleprincipale	* recommence
	
	trap	#15		* fin du programme (jamais atteint)
	dc.w	0
	
***           fin boucle principale           ***
	
*** debut de la routine de lecture du clavier ***
	
litclavier			* lecture du clavier dans cl
	move.b	#%00101011,PADDR	* lecture des lignes
	move.w	D0,D1		* enregistre l'ancienne valeur du clavier
	move.b	#numtest,D3	* reinitialise le compteur de tests
memetouche
	move.w	#$0,D0		* RAZ D0
	
bclav				* test ligne par ligne :
	ror.w	#$4,D0		* decale D0
	cmpi.b	#$0,D2		* mets le bon bit a 0 dans l'entre clavier
	bne	lbla1
	move.b	#%00101010,PADR
lbla1	
	cmpi.b	#$1,D2
	bne	lbla2
	move.b	#%00101001,PADR
lbla2	
	cmpi.b	#$2,D2
	bne	lbla3
	move.b	#%00100011,PADR
lbla3	
	cmpi.b	#$3,D2
	bne	lbla4
	move.b	#%00001011,PADR
lbla4	
	move.b	PADR,D7		* recupere le retour clavier dans D7
	
lblb0	
	btst	#$2,D7		* teste les touches de la ligne en cours
	bne	lblb1		* si le bit n'est pas zero, ne modifie pas D0
	bset	#$1,D0
lblb1	
	btst	#$4,D7
	bne	lblb2
	bset	#$2,D0
lblb2	
	btst	#$6,D7
	bne	lblb3
	bset	#$3,D0
lblb3	
	btst	#$7,D7
	bne	lblb4
	bset	#$4,D0
lblb4	
	dbra	D2,bclav	* il reste encore des lignes a lire
	
	cmp.w	D0,D1
	bne	litclavier	* si les touches ont chang, recommence
	
	dbra	D3,memetouche	* sinon teste encore une fois

	move.w	D1,(cl)		* sauvegarde le resultat de la lecture clavier
	
	rts			* fin de la procedure
	
***  fin de la routine de lecture du clavier  ***
	
***      debut de la routine d'affichage      ***
	
afficheecran			* affichage du buffer d'ecran sur la matrice
	move.l	#$03,PCDR	* synchronisation du MAX (reset)
	move.l	#$00,PCDR
	
	move.l	#$06,D0		* initialisation du compteur de ligne courant
	
	move.l	#af,A0		* met l'adresse de debut du buffer dans A0
	
affichesuiv
	move.b	#$01,PCDR	* clock pour eteindre la ligne
	move.b	#$00,PCDR
	
	move.b	(A0)+,PBDR	* mise a jour des anodes
	
	move.b	#$01,PCDR	* clock pour allumer la ligne
	move.b	#$00,PCDR
	
	bsr	tempo		* temporisation
	
	dbra	D0,affichesuiv	* ligne suivante
	
	rts
	
*** fin de la routine d'affichage de l'ecran  ***
	
***   debut de la routine de temporisation    ***
	
tempo
	move.l	#delai,D7
	
bcltempo
	nop
	dbra.l	D7,bcltempo
	
	rts
	
***    fin de la routine de temporisation     ***
	
	
*************************************************
**          declaration des variables          **
*************************************************
	
af	ds.b	8		* buffer ecran
	
cl	ds.w	1		* buffer de clavier
	
	END
