	xdef	START
	
	section	program,code
	
*************************************************
**         declaration des constantes          **
*************************************************
	
numtest	equ	20		* nombre de tests du clavier
delai	equ	100
	
PGCR	equ	$10001		* configuration globale
PACR	equ	$1000D
PBCR	equ	$1000F
PADDR	equ	$10005		* masque de lecture du port A
PBDDR	equ	$10007
PCDDR	equ	$10009
PADR	equ	$10011		* adresse du port A
PBDR	equ	$10013
PCDR	equ	$10019
	
	
	
	
	
*************************************************
**                debut du code                **
*************************************************
	
START
	move.b	#$00,PGCR	* initialisation du PIT
	move.b  #$C0,PACR
	move.b	#$C0,PBCR
	
	move.b	#%00101011,PADDR	* masque du clavier
	move.b	#$FF,PBDDR	* toutes les cathodes sont en ecriture
	move.b	#$03,PCDDR	* autorise clock($01) et reset($02) sur le MAX
	
	move.b	#$03,PCDR	* effectue un reset
	move.b	#$00,PCDR
	
	move.l	#af,A0
	move.b	#%01101111,(A0)+	* initiallisation du buffer lignes
	move.b	#%10101111,(A0)+
	move.b	#%11001111,(A0)+
	move.b	#%11100111,(A0)+
	move.b	#%11101011,(A0)+
	move.b	#%11101101,(A0)+
	move.b	#%11101110,(A0)
	
	
	
	
***      debut de la boucle principale        ***
	
boucleprincipale
	bsr	litclavier	* lit le clavier
	
	move.w	(cl),D0
	move.l	#af,A0		* fait pointer A0 sur l'ecran virtuel
	move.l	#ch0,A1		* fait pointer A1 sur le premier caractere

	test.w	D0		* si aucune touche n'est enfonce,
	beq	praffich	*  ne change pas l'affichage
	
	* move.b	$#0F,D1	* pour eviter les boucles infinies
prclav
	btst	#$0,D0		* si on trouve le premier bit allume
	beq	prrecopaffinit	* on affiche le caractere selectionne
	ror.w	#$1,D0		* sinon on regarde le bit suivant
	add.l	#$7,A1		* fait pointer A1 sur le caractere suivant
	bra	prclav		* dbra	D0,prclav	* pour eviter bouclage
	
	
prrecopaffinit
	move.l	#$6,D2		* 7 lignes a recopier
prrecopaffsuiv
	move.b	(A1)+,(A0)+	* recopie le buffer
	dbra	D2,prrecopaffsuiv	* regarde la ligne suivante
	
praffich
	bsr	permuteecran	* traduit l'ecran virtuel en ecran reel
	
	bsr	afficheecran	* affiche l'ecran
	
	bra	boucleprincipale	* recommence
	
	trap	#15		* fin du programme (jamais atteint)
	dc.w	0
	
***           fin boucle principale           ***
		


		
*** debut de la routine de permutation ecran  ***
	
permuteecran
	move.l	#af,A0		* charge l'adresse de l'ecran virtuel
	move.l	#ar,A1		* charge l'adresse de l'ecran reel
	
	move.b	#$7,D6		* va recopier 7 lignes
permlignesuiv
	move.b	(A0)+,D0	* recopie la ligne virtuelle
	move.b	#$EF,D1		* initialise la vraie ligne
	move.l	#tabperaf,A2	* charge l'adresse de la table de permutations
	
	move.b	#$7,D7		* va recopier 7 bits
permbitsuiv
	move.l	(A2),D2		* charge la position du bit en cours
	add.l	#$4,A2		* pointe sur la ligne suivante de la table
	btst	#$0,D0
	beq	bitvide
	bclr	D2,D1		* met le bit correspondant a 0
bitvide
	rol.b	#$1,D0		* regarde le bit suivant de D0
	
	dbra	D7,permbitsuiv

	move.b	D1,(A1)+	* sauvegarde la ligne qui vient d'etre permutee
	
	dbra	D6,permlignesuiv
	
	rts
	
***  fin de la routine de permutation ecran   ***
	


	
*** debut de la routine de lecture du clavier ***
	
litclavier			* lecture du clavier dans cl
	move.b	#%00101011,PADDR	* lignes en lecture
	move.w	D0,D1		* enregistre l'ancienne valeur du clavier
	move.b	#numtest,D3	* reinitialise le compteur de tests
memetouche
	move.w	#$0,D0		* RAZ D0
	
bclav				* test ligne par ligne :
	rol.w	#$4,D0		* decale D0
	cmpi.b	#$0,D2		* mets le bon bit a 0 dans l'entre clavier
	bne	lbla1
	move.b	#%00101010,PADR
lbla1	
	cmpi.b	#$1,D2
	bne	lbla2
	move.b	#%00101001,PADR
lbla2	
	cmpi.b	#$2,D2
	bne	lbla3
	move.b	#%00100011,PADR
lbla3	
	cmpi.b	#$3,D2
	bne	lbla4
	move.b	#%00001011,PADR
lbla4	
	move.b	PADR,D7		* recupere le retour clavier dans D7
	
lblb0	
	btst	#$2,D7		* teste les touches de la ligne en cours
	bne	lblb1		* si le bit n'est pas zero, ne modifie pas D0
	bset	#$1,D0
lblb1	
	btst	#$4,D7
	bne	lblb2
	bset	#$2,D0
lblb2	
	btst	#$6,D7
	bne	lblb3
	bset	#$3,D0
lblb3	
	btst	#$7,D7
	bne	lblb4
	bset	#$4,D0
lblb4	
	dbra	D2,bclav	* il reste encore des lignes a lire
	
	cmp.w	D0,D1
	bne	litclavier	* si les touches ont chang, recommence
	
	dbra	D3,memetouche	* sinon teste encore une fois

	move.w	D1,(cl)		* sauvegarde le resultat de la lecture clavier
	
	rts			* fin de la procedure
	
***  fin de la routine de lecture du clavier  ***
	

	
	
***      debut de la routine d'affichage      ***
	
afficheecran			* affichage du buffer d'ecran sur la matrice
	move.l	#$03,PCDR	* synchronisation du MAX (reset)
	move.l	#$00,PCDR
	
	move.l	#$06,D0		* initialisation du compteur de ligne courant
	
	move.l	#ar,A0		* met l'adresse de debut du buffer dans A0
	
affichesuiv
	move.b	#$01,PCDR	* clock pour eteindre la ligne
	move.b	#$00,PCDR
	
	move.b	(A0)+,PBDR	* mise a jour des anodes
	
	move.b	#$01,PCDR	* clock pour allumer la ligne
	move.b	#$00,PCDR
	
	bsr	tempo		* temporisation
	
	dbra	D0,affichesuiv	* ligne suivante
	
	rts
	
*** fin de la routine d'affichage de l'ecran  ***
	
	

	
***   debut de la routine de temporisation    ***
	
tempo
	move.l	#delai,D7
	
bcltempo
	nop
	dbra.l	D7,bcltempo
	
	rts
	
***    fin de la routine de temporisation     ***
	
	

	
	
*************************************************
**          declaration des variables          **
*************************************************
	
af	ds.b	8		* buffer ecran virtuel
ar	ds.b	8		* buffer ecran reel (apres permutation)

tabperaf
	dc.l	$0		* position reele du 1 bit de la ligne virtuelle
	dc.l	$1
	dc.l	$2
	dc.l	$3
	dc.l	$5
	dc.l	$6
	dc.l	$7
	
cl	ds.w	1		* buffer de clavier

ch0	ds.b	%1111111	* image des chiffres a afficher (0)
	ds.b	%1110111
	ds.b	%1001001
	ds.b	%1011101
	ds.b	%1001001
	ds.b	%1110111
	ds.b	%1111111
	
ch1	ds.b	%1111111	* image des chiffres a afficher (1)
	ds.b	%1110111
	ds.b	%1100111
	ds.b	%1010111
	ds.b	%1110111
	ds.b	%1100011
	ds.b	%1111111
	
ch2	ds.b	%1111111	* image des chiffres a afficher (2)
	ds.b	%1100011
	ds.b	%1011101
	ds.b	%1111011
	ds.b	%1100111
	ds.b	%1000001
	ds.b	%1111111
	
ch3	ds.b	%1111111	* image des chiffres a afficher (3)
	ds.b	%1100011
	ds.b	%1011101
	ds.b	%1110011
	ds.b	%1011101
	ds.b	%1100011
	ds.b	%1111111
	
ch4	ds.b	%1111111	* image des chiffres a afficher (4)
	ds.b	%1111011
	ds.b	%1110111
	ds.b	%1101011
	ds.b	%1000001
	ds.b	%1111011
	ds.b	%1111111

ch5	ds.b	%1111111	* image des chiffres a afficher (5)
	ds.b	%1000001
	ds.b	%1011111
	ds.b	%1000011
	ds.b	%1111101
	ds.b	%1000011
	ds.b	%1111111
	
ch6	ds.b	%1111111	* image des chiffres a afficher (0)
	ds.b	%1110001
	ds.b	%1101111
	ds.b	%1000011
	ds.b	%1011101
	ds.b	%1100011
	ds.b	%1111111
	
ch7	ds.b	%1111111	* image des chiffres a afficher (7)
	ds.b	%1000001
	ds.b	%1110111
	ds.b	%1101111
	ds.b	%1011111
	ds.b	%1011111
	ds.b	%1111111
	
ch8	ds.b	%1111111	* image des chiffres a afficher (8)
	ds.b	%1100011
	ds.b	%1011101
	ds.b	%1100011
	ds.b	%1011101
	ds.b	%1100011
	ds.b	%1111111

ch9	ds.b	%1111111	* image des chiffres a afficher (9)
	ds.b	%1100011
	ds.b	%1011101
	ds.b	%1100001
	ds.b	%1111101
	ds.b	%1100011
	ds.b	%1111111
	
chA	ds.b	%1111111	* image des chiffres a afficher (A)
	ds.b	%1110111
	ds.b	%1101011
	ds.b	%1101011
	ds.b	%1000001
	ds.b	%1011101
	ds.b	%1111111
	
chB	ds.b	%1111111	* image des chiffres a afficher (B)
	ds.b	%1000011
	ds.b	%1011101
	ds.b	%1000011
	ds.b	%1011101
	ds.b	%1000011
	ds.b	%1111111
	
chC	ds.b	%1111111	* image des chiffres a afficher (C)
	ds.b	%1100011
	ds.b	%1011101
	ds.b	%1011111
	ds.b	%1011101
	ds.b	%1100011
	ds.b	%1111111
	
chD	ds.b	%1111111	* image des chiffres a afficher (D)
	ds.b	%1000011
	ds.b	%1011101
	ds.b	%1011101
	ds.b	%1011101
	ds.b	%1000011
	ds.b	%1111111
	
chE	ds.b	%1111111	* image des chiffres a afficher (E)
	ds.b	%1000001
	ds.b	%1011111
	ds.b	%1000011
	ds.b	%1011111
	ds.b	%1000001
	ds.b	%1111111
	
chF	ds.b	%1111111	* image des chiffres a afficher (F)
	ds.b	%1000001
	ds.b	%1011111
	ds.b	%1000011
	ds.b	%1011111
	ds.b	%1011111
	ds.b	%1111111
	
	END
