	xdef	START
	
	section	program,code
	
	
********************************
** declaration des constantes **
********************************
	
delai	equ	100		* delai d'affichage
	
PGCR	equ	$10001		* configuration globale
PACR	equ	$1000D
PBCR	equ	$1000F
PADDR	equ	$10005		* masque de lecture du port A
PBDDR	equ	$10007
PCDDR	equ	$10009
PADR	equ	$10011		* adresse du port A
PBDR	equ	$10013
PCDR	equ	$10019
	
	
*******************
** debut du code **
*******************
	
START
	move.b	#$00,PGCR	* initialisation du PIT
	move.b  #$C0,PACR
	move.b	#$C0,PBCR
	
	move.b	#$FF,PBDDR	* toutes les cathodes sont en ecriture
	move.b	#$03,PCDDR	* autorise clock($01) et reset($02) sur le MAX
	
	move.b	#$03,PCDR	* effectue un reset
	move.b	#$00,PCDR
	
	move.b	#%01101111,(l0)	* initiallisation du buffer lignes
	move.b	#%10101111,(l1)
	move.b	#%11001111,(l2)
	move.b	#%11100111,(l3)
	move.b	#%11101011,(l4)
	move.b	#%11101101,(l5)
	move.b	#%11101110,(l6)
	
boucleprincipale
	bsr	afficheecran	* affiche l'ecran, c'est tout
	
	bra	boucleprincipale
	
	trap	#15		* fin du programme
	dc.w	0
	
	
afficheecran			* affichage du buffer d'ecran sur la matrice
	move.l	#$03,PCDR	* synchronisation du MAX (reset)
	move.l	#$00,PCDR
	
	move.l	#$06,D0		* initialisation du compteur de ligne courant
	
	move.l	#l0,A0		* met l'adresse de l6 dans A0
	
affichesuiv
	move.b	#$01,PCDR	* clock pour eteindre la ligne
	move.b	#$00,PCDR
	
	move.b	(A0)+,PBDR	* mise a jour des anodes
	
	move.b	#$01,PCDR	* clock pour allumer la ligne
	move.b	#$00,PCDR
	
	bsr	tempo		* temporisation
	
	dbra	D0,affichesuiv	* ligne suivante
	
	rts
	
	
tempo
	move.l	#delai,D7
	
bcltempo
	nop
	dbra.l	D7,bcltempo
	
	rts
	
	
*******************************
** declaration des variables **
*******************************
	
l0	dc.b	$EF		* init. du buffer ecran, diodes eteintes
l1	dc.b	$EF
l2	dc.b	$EF
l3	dc.b	$EF
l4	dc.b	$EF
l5	dc.b	$EF
l6	dc.b	$EF
	
	END
