GUILLOT NAHRY Gr4.2

		org	$FF9100



		xdef	_lectclavier,_PITinit,_nbtestsvict,_tabvictX,_tabvictY,_sti,_cli,_exxit

		xref	_testvictoire



		section	program,code







**************************************************

*                   constantes                   *

**************************************************



***** pour le programme *****

clav_numtest	equ	$8	; nombre de tests comparatifs des touches



dureechute	equ	$FF	; duree de stationnement dans une case sans plancher (mask)

maskclignj2	equ	$100	; periode de clignotement du joueur 2 (bit)





***** adresses *****

PGCR		equ	$10001

PADDR		equ	$10005		; masque d'io

PBDDR		equ	$10007

PCDDR		equ	$10009

PADR		equ	$10011		; valeur des bus

PBDR		equ	$10013

PCDR		equ	$10019

PACR		equ	$1000d

PBCR		equ	$1000f

	

TCR		equ	$10021		; adresses pour setup interruptions

TIVR		equ	$10023

CPR		equ	$27

CNTR		equ	$2F

TSR		equ	$10035

		







************************************************

*           initialisation du PIT              *

************************************************

_PITinit

	link	A6,#0

	movem.l	D0-D7/A0-A6,-(A7)



	move.l	8(A6),D0	; delta_t



	move.l	12(A6),A3	; &ptab_chute

	move.l	#tab_chute,(A3)



	move.l	16(A6),A3

	move.l	#tab_oqp,(A3)



	move.l	20(A6),A3

	move.l	#tab_j,(A3)



	move.w	#$2700,SR	; interdit les interrupts pendant l'initialisation



	move.l	#$FFFF83FC,A1	; adresse du vecteur 255

	lea	timerih,A2	; adresse du gestionnaire



	move.l	A2,(A1)		; init vecteur 255 avec la fonction qui va bien

	

	move.l	#$10000,A0	; adresse de base du PIT230

	move.b	#$00,PGCR	; initialisation du PIT en mode 0

	move.b	#$C0,PACR	; ports en mode 1x

	move.b	#$C0,PBDR

	move.b	#$FF,PBDDR	; les cathodes sont en ecriture

	move.b	#$03,PCDDR	; autorise clock($02) et reset($01)



	move.b	#$FF,PADR

	move.b	#$FF,PBDR

	move.l	#6,ligneaff

	move.l	#0,time

	move.l	#0,_nbtestsvict

	move.b	#1,PCDR		; reset

	move.b	#0,PCDR



	move.b	#$FF,TIVR	; on selectionne l'interruption 255

	movep.l	D0,CPR-2(A0)	; programmation du timer

	movep.l	D0,CNTR-2(A0)

	move.b	#$A1,TCR

	move.w	#$2000,SR	; autorise interrupts



	movem.l	-60(A6),D0-D7/A0-A6

	unlk	A6

	rts	

		







*** autorise les interrupts ***

_sti

	move.w	#$2000,SR

	rts







*** interdit les interrupts ***

_cli

	move.w	#$2700,SR

	rts







*** terminaison du programme ***

_exxit	

	trap	#15

	ds.w	0







*************************************************

*        routine de lecture du clavier          *

*************************************************



_lectclavier			; lecture du clavier (dans D0)

	link	A6,#0

	movem.l	D1-D7/A0-A6,-(A7)



	move.b	#%11010100,PADDR ; positionne les lignes en ecriture

clav_start

	move.l	#clav_numtest,D3 ; reinitialise le compteur de tests



clav_memetouche

	move.l	D0,D1		; sauvegarde l'ancienne valeur du clavier

	move.l	#0,D0		; RAZ D0

	move.l	#3,D2		; 4 colonnes a tester

	

clav_boucle			; test colonne par colonne

	rol.l	#4,D0		; decale D0 qui contient le resultat du test de 4 bits



* mise a 0 de la colonne a tester *

	cmp.l	#0,D2

	bne	clav_settest1

	move.b	#%11010000,PADR	; 1 test : eteint la premiere colonne

	bra	clav_finsettest

clav_settest1

	cmp.l	#2,D2

	bne	clav_settest2

	move.b	#%11000100,PADR	; 2 test : eteint la deuxieme

	bra	clav_finsettest

clav_settest2

	cmp.l	#3,D2

	bne	clav_settest3

	move.b	#%10010100,PADR ; 3 test : eteint la troisieme

	bra	clav_finsettest

clav_settest3

	move.b	#%01010100,PADR	, 4 test : eteint la derniere

	nop

clav_finsettest

	move.b	PADR,D7		; recupere le retour clavier dans D7

	

	btst	#0,D7		; teste les touches de la colonne en cours

	bne	clav_gettest1	; si le bit n'est pas zero, ne modifie pas D0

	bset	#1,D0

clav_gettest1

	btst	#1,D7

	bne	clav_gettest2

	bset	#0,D0

clav_gettest2

	btst	#3,D7

	bne	clav_gettest3

	bset	#3,D0

clav_gettest3

	btst	#5,D7

	bne	clav_fingettest

	bset	#2,D0

clav_fingettest



	dbra	D2,clav_boucle	; va tester la colonne suivante s'il en reste

	

	cmp.l	D0,D1		; compare avec le resultat du test precedant

	bne	clav_start	; si les touches ont chang, recommence a 0

	

	dbra	D3,clav_memetouche ; teste clav_numtest fois



clav_fin

	movem.l	-56(A6),D1-D7/A0-A6

	unlk	A6

	rts

















*************************************************

* debut de la routine de gestion d'interruption *

*************************************************



timerih

	link	A6,#0

	movem.l	D0-D7/A0-A6,-(A7) ; sauvegarde des registres sur la pile



	move.b	#1,TSR		; relance le timer





	add.l	#1,time		; le temps passe



	bsr	lsuiv_start

	

	move.l	time,D0

	and.l	#dureechute,D0	; est-il l'heure de gerer les chutes ?

	bne	timerih_fin	; non

	bsr	chute_start	; si



timerih_fin

	movem.l	-60(A6),D0-D7/A0-A6 ; restauration a partir de la pile

	unlk	A6

	

	rte			; retour d'interruption









********************************************************

* debut de la routine d'affichage de la ligne suivante *

********************************************************

	

lsuiv_start

	move.b	#2,PCDR		; extinction de la ligne precedante par le MAX

	move.b	#0,PCDR

	move.b	#$FE,PBDR	; extinction de la ligne par le PIT (pour eviter les fantomes)

	

	move.l	ligneaff,D0	; gestion du compteur de ligne decroissant modulo 7

	dbra	D0,lsuiv_lbl1

	move.l	#6,D0

	move.b	#1,PCDR		; reset

	move.b	#0,PCDR

lsuiv_lbl1

	move.l	D0,ligneaff

	

	lea	tab_chute,A0	; initialise les Ax avec les adresses des differents buffers

	lea	tab_oqp,A1

	lea	tab_j,A2



	move.b	(A0,D0),D1	; affiche a la fois les pions en chute

	or.b	(A1,D0),D1	; et les pions fixes

	move.b	(A2,D0),D2	; lit la ligne en cours du buffer de joueur dans D2



	move.l	time,D3		; lit l'heure

	and.l	#maskclignj2,D3 ; les pions de j2 sont allumes ?

	bne	lsuiv_lbl2

	move.b	#0,D2		; oui : efface D2

lsuiv_lbl2



	and.b	D1,D2		; on elimine les cases residuelles sans pions mais avec j positionne

	eor.b	D2,D1		; et hop !

	not.b	D1



	move.b	D1,PBDR		; mise a jour des anodes

	move.b	#2,PCDR		; allumage de la ligne courante par le MAX

	move.b	#0,PCDR

	

	rts			; fin de la routine









********************************************************

* debut de la routine de gestion de la chute des pions *

********************************************************

	

chute_start

	lea	tab_chute,A0	; initialise les Ax avec les adresses des differents buffers

	lea	tab_oqp,A1

	lea	tab_j,A2

	move.b	#$EF,D6		; initialise le tampon de tab_oqp(l-1) a 1 : les pions de la 1 ligne doivent s'arreter

	move.l	#0,D2		; commence par le bas du tableau en remontant

	

chute_lboucle			; debut de la boucle sur les lignes

	move.b	(A0,D2),D3	; lit la ligne en cours de tab_chute

	beq	chute_lfinie	; si elle est nulle, aucun pion en chute sur cette ligne : passe a la suivante



	move.l	#7,D1		; on teste les 8 bits de la ligne



chute_bboucle			; debut de la boucle sur les bits

	btst	D1,D3		; regarde si il y a un pion en chute dans la case (D1,D2)

	beq	chute_bfini	; il n'y en a pas : regarde le bit suivant



	btst	D1,D6		; regarde si la case du dessous est occupe

	beq	chute_continue	; non : fait tomber le pion d'une case



	bclr	D1,(A0,D2)	; oui : enleve le pion de tab_chute

	bset	D1,(A1,D2)	; pour le mettre dans tab_oqp (tab_j est a jour)





	lea	_tabvictX,A4	; on charge les adresses des debuts de tableaux

	lea	_tabvictY,A5

	add.l	#1,_nbtestsvict	; et on met a jour la taille du tableau

	move.l	_nbtestsvict,D0

	add.l	D0,D0		; D0 = D0 * 4 

	add.l	D0,D0		; (4 = sizeof (unsigned long))

	move.l	D1,(A4,D0)	; et on y enregistre les coordonnees du jeton courant

	move.l	D2,(A5,D0)



	bra	chute_bfini	; et on continue les tests au bit suivant de la ligne en cours



chute_continue

	bclr	D1,(A0,D2)	; met a jour tab_chute

	bset	D1,-1(A0,D2)    

	bclr	D1,(A2,D2)	; met a jour tab_j

	beq	chute_bfini	; (bclr fait un btst en meme temps)

	bset	D1,-1(A2,D2)	; la case tait occupe par le joueur 2 : on lui laisse le pion



chute_bfini

	dbra	D1,chute_bboucle ; regarde le bit suivant



chute_lfinie

	move.b	(A1,D2),D6	; enregistre la ligne de presence de l'ancienne ligne dans D6

	add.l	#1,D2		; incremente la ligne en cours

	cmp.l	#7,D2

	bne	chute_lboucle	; et on recommence jusqu'a la premiere ligne du tableau



	rts			; fin de la routine



















*************************************************

**          declaration des variables          **

*************************************************



time		dc.l	0	; compteur de temps

ligneaff	dc.l	0	; derniere ligne affiche (pour l'interrupt)



_delta_t	dc.l	0	; frequence de rafraichissement





* tableaux : 7 lignes (0..6), ligne 6 = ligne du haut sur l'afficheur, +1 ligne pour l'alignement

* les bits sont dans l'ordre des cathodes

* les pions en chute ne sont pas dans tab_oqp

tab_chute	ds.b	8	; buffer, 1 = jeton en chute

tab_oqp		ds.b	8	; buffer, 1 = jeton present

tab_j		ds.b	8	; buffer, 1 = jeton au joueur 2

		

		even

_nbtestsvict	dc.l	0	; taille des tableaux suivant

_tabvictX	ds.l	50	; place pour les tableaux contenant les coordonnees

_tabvictY	ds.l	50	; des jetons fraichement tombes

		END

